const express = require("express");
var http = require("http");
const app = express();
const port = process.env.PORT || 3000;
var server = http.createServer(app);
var io = require("socket.io")(server);

app.use(express.json());

io.on("connection", (socket) => {

  // sending the points to the clients
  socket.on("paint", (pointDetails) => {
    io.emit("points", { details: pointDetails });
  });

  socket.on("clean-screen", () => {
    // sending the request to clean screen
    io.emit("clean-screen", "");
  });

  socket.on("stroke-width", (stroke) => {
    // sending the stroke width to clients
    io.emit("stroke-width", stroke);
  });

  socket.on("color-change", async (color) => {
    // sending new color to clients
    io.emit("color-change", color);
  });
});

// listening to the server
server.listen(port, () => {
  console.log("server started & running on " + port);
});
